package cz.cvut.and.tutorial08;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.telephony.SmsMessage;
import android.widget.Toast;

public class SMSReceiver extends BroadcastReceiver {

	@Override
	public void onReceive(Context context, Intent intent) {

		Bundle bundle = intent.getExtras();
		Object[] pdus = (Object[]) bundle.get("pdus");
		SmsMessage[] messages = new SmsMessage[pdus.length];

		// get all incoming sms messages
		for (int i = 0; i < messages.length; i++) {
			messages[i] = SmsMessage.createFromPdu((byte[]) pdus[i]);
		}

		// try to append message bodies from the same number
		StringBuilder text = new StringBuilder();
		String lastNumber = null;
		for (SmsMessage message : messages) {
			if (lastNumber == null
					|| lastNumber.equals(message.getDisplayOriginatingAddress())) {
				text.append(message.getDisplayMessageBody());
			} else {
				showToast(context, text.toString(), lastNumber);
				text.setLength(0);
			}
			lastNumber = message.getDisplayOriginatingAddress();
		}

		if (text.length() > 0) {
			showToast(context, text.toString(), lastNumber);
		}

	}

	private void showToast(Context context, String text, String number) {
		Toast.makeText(context, number + ": " + text, Toast.LENGTH_LONG).show();
	}

}
